model schellinggrid

global {
	float density <- 0.9;
	float preference <- 0.7;
	int distance <- 5;
	init {
		int nb_people <- int(length(house) * density);
		loop h over: nb_people among shuffle(house) {
		      create people {
		            my_house <- h;
		            location <- h.location;
		            h.is_empty<- false;
		      }
		}
	}
}

grid house width:30 height:30 neighbors:8 {
	bool is_empty <- true;
}

species people {
	house my_house;
	rgb color <- flip(0.5) ? #red : #yellow;
	bool is_happy;
	
	reflex move when: not is_happy {
		my_house.is_empty <- true;
		my_house <- one_of (house where each.is_empty);
		location <- my_house.location;
		my_house.is_empty <- false;
	}
	
	reflex compute_happiness {
		list<people> neigbours_pp <- people at_distance distance;
		int nb_neighbours <- length(neigbours_pp);
		int nb_neighbours_diff<- neigbours_pp count (each.color != color);
		is_happy <- (nb_neighbours = 0) or ((nb_neighbours_diff /nb_neighbours) < preference) ;
	}
	
	aspect default {
		draw circle(1.0) color: color;
	}
}

experiment my_GUI_xp type:gui {
	parameter"density" var:density;
	parameter"preference" var:preference;
	parameter"distance" var:distance;
	output{
		display map {
			grid house border: rgb(0,0,0);
			species people;
		}
	}
}
